// <auto-generated />
// This file was generated by a T4 template.
// Don't change it directly as your change would get overwritten.  Instead, make changes
// to the .tt file (i.e. the T4 template) and save it to regenerate this file.

// Make sure the compiler doesn't complain about missing Xml comments and CLS compliance
// 0108: suppress "Foo hides inherited member Foo. Use the new keyword if hiding was intended." when a controller and its abstract parent are both processed
// 0114: suppress "Foo.BarController.Baz()' hides inherited member 'Qux.BarController.Baz()'. To make the current member override that implementation, add the override keyword. Otherwise add the new keyword." when an action (with an argument) overrides an action in a parent controller
#pragma warning disable 1591, 3008, 3009, 0108, 0114
#region T4MVC

using System;
using System.Diagnostics;
using System.CodeDom.Compiler;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Threading.Tasks;
using System.Web;
using System.Web.Hosting;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using System.Web.Mvc.Html;
using System.Web.Routing;
using T4MVC;
namespace LoyaltyPointEngine.CMS.Controllers
{
    public partial class PromoController
    {
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public PromoController() { }

        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        protected PromoController(Dummy d) { }

        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        protected RedirectToRouteResult RedirectToAction(ActionResult result)
        {
            var callInfo = result.GetT4MVCResult();
            return RedirectToRoute(callInfo.RouteValueDictionary);
        }

        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        protected RedirectToRouteResult RedirectToAction(Task<ActionResult> taskResult)
        {
            return RedirectToAction(taskResult.Result);
        }

        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        protected RedirectToRouteResult RedirectToActionPermanent(ActionResult result)
        {
            var callInfo = result.GetT4MVCResult();
            return RedirectToRoutePermanent(callInfo.RouteValueDictionary);
        }

        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        protected RedirectToRouteResult RedirectToActionPermanent(Task<ActionResult> taskResult)
        {
            return RedirectToActionPermanent(taskResult.Result);
        }

        [NonAction]
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public virtual System.Web.Mvc.ActionResult Index()
        {
            return new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.Index);
        }
        [NonAction]
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public virtual System.Web.Mvc.ActionResult Detail()
        {
            return new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.Detail);
        }
        [NonAction]
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public virtual System.Web.Mvc.ActionResult Edit()
        {
            return new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.Edit);
        }
        [NonAction]
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public virtual System.Web.Mvc.ActionResult EditDetail()
        {
            return new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.EditDetail);
        }
        [NonAction]
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public virtual System.Web.Mvc.ActionResult GridGetAllPromoDetail()
        {
            return new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.GridGetAllPromoDetail);
        }
        [NonAction]
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public virtual System.Web.Mvc.ActionResult GridGetAllPromoPager()
        {
            return new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.GridGetAllPromoPager);
        }
        [NonAction]
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public virtual System.Web.Mvc.ActionResult GridGetAllPromoDetailPager()
        {
            return new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.GridGetAllPromoDetailPager);
        }
        [NonAction]
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public virtual System.Web.Mvc.JsonResult CheckDuplicatePromoCode()
        {
            return new T4MVC_System_Web_Mvc_JsonResult(Area, Name, ActionNames.CheckDuplicatePromoCode);
        }
        [NonAction]
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public virtual System.Web.Mvc.ActionResult UploadFromExel()
        {
            return new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.UploadFromExel);
        }

        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public PromoController Actions { get { return MVC.Promo; } }
        [GeneratedCode("T4MVC", "2.0")]
        public readonly string Area = "";
        [GeneratedCode("T4MVC", "2.0")]
        public readonly string Name = "Promo";
        [GeneratedCode("T4MVC", "2.0")]
        public const string NameConst = "Promo";
        [GeneratedCode("T4MVC", "2.0")]
        static readonly ActionNamesClass s_actions = new ActionNamesClass();
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public ActionNamesClass ActionNames { get { return s_actions; } }
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public class ActionNamesClass
        {
            public readonly string Index = "Index";
            public readonly string Add = "Add";
            public readonly string AddJson = "AddJson";
            public readonly string Detail = "Detail";
            public readonly string DownloadExcelTemplate = "DownloadExcelTemplate";
            public readonly string Edit = "Edit";
            public readonly string EditDetail = "EditDetail";
            public readonly string GridGetAllPromo = "GridGetAllPromo";
            public readonly string GridGetAllPromoDetail = "GridGetAllPromoDetail";
            public readonly string GridGetAllPromoPager = "GridGetAllPromoPager";
            public readonly string GridGetAllPromoDetailPager = "GridGetAllPromoDetailPager";
            public readonly string CheckDuplicatePromoCode = "CheckDuplicatePromoCode";
            public readonly string UploadFromExel = "UploadFromExel";
        }

        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public class ActionNameConstants
        {
            public const string Index = "Index";
            public const string Add = "Add";
            public const string AddJson = "AddJson";
            public const string Detail = "Detail";
            public const string DownloadExcelTemplate = "DownloadExcelTemplate";
            public const string Edit = "Edit";
            public const string EditDetail = "EditDetail";
            public const string GridGetAllPromo = "GridGetAllPromo";
            public const string GridGetAllPromoDetail = "GridGetAllPromoDetail";
            public const string GridGetAllPromoPager = "GridGetAllPromoPager";
            public const string GridGetAllPromoDetailPager = "GridGetAllPromoDetailPager";
            public const string CheckDuplicatePromoCode = "CheckDuplicatePromoCode";
            public const string UploadFromExel = "UploadFromExel";
        }


        static readonly ActionParamsClass_Index s_params_Index = new ActionParamsClass_Index();
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public ActionParamsClass_Index IndexParams { get { return s_params_Index; } }
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public class ActionParamsClass_Index
        {
            public readonly string status = "status";
        }
        static readonly ActionParamsClass_Detail s_params_Detail = new ActionParamsClass_Detail();
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public ActionParamsClass_Detail DetailParams { get { return s_params_Detail; } }
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public class ActionParamsClass_Detail
        {
            public readonly string id = "id";
            public readonly string status = "status";
        }
        static readonly ActionParamsClass_Edit s_params_Edit = new ActionParamsClass_Edit();
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public ActionParamsClass_Edit EditParams { get { return s_params_Edit; } }
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public class ActionParamsClass_Edit
        {
            public readonly string id = "id";
            public readonly string model = "model";
        }
        static readonly ActionParamsClass_EditDetail s_params_EditDetail = new ActionParamsClass_EditDetail();
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public ActionParamsClass_EditDetail EditDetailParams { get { return s_params_EditDetail; } }
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public class ActionParamsClass_EditDetail
        {
            public readonly string id = "id";
        }
        static readonly ActionParamsClass_GridGetAllPromoDetail s_params_GridGetAllPromoDetail = new ActionParamsClass_GridGetAllPromoDetail();
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public ActionParamsClass_GridGetAllPromoDetail GridGetAllPromoDetailParams { get { return s_params_GridGetAllPromoDetail; } }
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public class ActionParamsClass_GridGetAllPromoDetail
        {
            public readonly string idp = "idp";
        }
        static readonly ActionParamsClass_GridGetAllPromoPager s_params_GridGetAllPromoPager = new ActionParamsClass_GridGetAllPromoPager();
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public ActionParamsClass_GridGetAllPromoPager GridGetAllPromoPagerParams { get { return s_params_GridGetAllPromoPager; } }
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public class ActionParamsClass_GridGetAllPromoPager
        {
            public readonly string txtSearch = "txtSearch";
            public readonly string page = "page";
        }
        static readonly ActionParamsClass_GridGetAllPromoDetailPager s_params_GridGetAllPromoDetailPager = new ActionParamsClass_GridGetAllPromoDetailPager();
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public ActionParamsClass_GridGetAllPromoDetailPager GridGetAllPromoDetailPagerParams { get { return s_params_GridGetAllPromoDetailPager; } }
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public class ActionParamsClass_GridGetAllPromoDetailPager
        {
            public readonly string txtSearch = "txtSearch";
            public readonly string idp = "idp";
            public readonly string page = "page";
        }
        static readonly ActionParamsClass_CheckDuplicatePromoCode s_params_CheckDuplicatePromoCode = new ActionParamsClass_CheckDuplicatePromoCode();
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public ActionParamsClass_CheckDuplicatePromoCode CheckDuplicatePromoCodeParams { get { return s_params_CheckDuplicatePromoCode; } }
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public class ActionParamsClass_CheckDuplicatePromoCode
        {
            public readonly string promoCode = "promoCode";
        }
        static readonly ActionParamsClass_UploadFromExel s_params_UploadFromExel = new ActionParamsClass_UploadFromExel();
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public ActionParamsClass_UploadFromExel UploadFromExelParams { get { return s_params_UploadFromExel; } }
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public class ActionParamsClass_UploadFromExel
        {
            public readonly string excelFile = "excelFile";
            public readonly string id = "id";
        }
        static readonly ViewsClass s_views = new ViewsClass();
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public ViewsClass Views { get { return s_views; } }
        [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
        public class ViewsClass
        {
            static readonly _ViewNamesClass s_ViewNames = new _ViewNamesClass();
            public _ViewNamesClass ViewNames { get { return s_ViewNames; } }
            public class _ViewNamesClass
            {
                public readonly string Add = "Add";
                public readonly string Detail = "Detail";
                public readonly string Edit = "Edit";
                public readonly string EditDetail = "EditDetail";
                public readonly string GridGetAllPromo = "GridGetAllPromo";
                public readonly string GridGetAllPromoDetail = "GridGetAllPromoDetail";
                public readonly string Index = "Index";
                public readonly string UploadFromExel = "UploadFromExel";
            }
            public readonly string Add = "~/Views/Promo/Add.cshtml";
            public readonly string Detail = "~/Views/Promo/Detail.cshtml";
            public readonly string Edit = "~/Views/Promo/Edit.cshtml";
            public readonly string EditDetail = "~/Views/Promo/EditDetail.cshtml";
            public readonly string GridGetAllPromo = "~/Views/Promo/GridGetAllPromo.cshtml";
            public readonly string GridGetAllPromoDetail = "~/Views/Promo/GridGetAllPromoDetail.cshtml";
            public readonly string Index = "~/Views/Promo/Index.cshtml";
            public readonly string UploadFromExel = "~/Views/Promo/UploadFromExel.cshtml";
        }
    }

    [GeneratedCode("T4MVC", "2.0"), DebuggerNonUserCode]
    public partial class T4MVC_PromoController : LoyaltyPointEngine.CMS.Controllers.PromoController
    {
        public T4MVC_PromoController() : base(Dummy.Instance) { }

        [NonAction]
        partial void IndexOverride(T4MVC_System_Web_Mvc_ActionResult callInfo, string status);

        [NonAction]
        public override System.Web.Mvc.ActionResult Index(string status)
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.Index);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "status", status);
            IndexOverride(callInfo, status);
            return callInfo;
        }

        [NonAction]
        partial void AddOverride(T4MVC_System_Web_Mvc_ActionResult callInfo);

        [NonAction]
        public override System.Web.Mvc.ActionResult Add()
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.Add);
            AddOverride(callInfo);
            return callInfo;
        }

        [NonAction]
        partial void AddJsonOverride(T4MVC_System_Web_Mvc_ActionResult callInfo);

        [NonAction]
        public override System.Web.Mvc.ActionResult AddJson()
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.AddJson);
            AddJsonOverride(callInfo);
            return callInfo;
        }

        [NonAction]
        partial void DetailOverride(T4MVC_System_Web_Mvc_ActionResult callInfo, int id, string status);

        [NonAction]
        public override System.Web.Mvc.ActionResult Detail(int id, string status)
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.Detail);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "id", id);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "status", status);
            DetailOverride(callInfo, id, status);
            return callInfo;
        }

        [NonAction]
        partial void DownloadExcelTemplateOverride(T4MVC_System_Web_Mvc_ActionResult callInfo);

        [NonAction]
        public override System.Web.Mvc.ActionResult DownloadExcelTemplate()
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.DownloadExcelTemplate);
            DownloadExcelTemplateOverride(callInfo);
            return callInfo;
        }

        [NonAction]
        partial void EditOverride(T4MVC_System_Web_Mvc_ActionResult callInfo, int id);

        [NonAction]
        public override System.Web.Mvc.ActionResult Edit(int id)
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.Edit);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "id", id);
            EditOverride(callInfo, id);
            return callInfo;
        }

        [NonAction]
        partial void EditDetailOverride(T4MVC_System_Web_Mvc_ActionResult callInfo, int id);

        [NonAction]
        public override System.Web.Mvc.ActionResult EditDetail(int id)
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.EditDetail);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "id", id);
            EditDetailOverride(callInfo, id);
            return callInfo;
        }

        [NonAction]
        partial void EditOverride(T4MVC_System_Web_Mvc_ActionResult callInfo, LoyaltyPointEngine.Model.Object.Promo.PromoModel model);

        [NonAction]
        public override System.Web.Mvc.ActionResult Edit(LoyaltyPointEngine.Model.Object.Promo.PromoModel model)
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.Edit);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "model", model);
            EditOverride(callInfo, model);
            return callInfo;
        }

        [NonAction]
        partial void GridGetAllPromoOverride(T4MVC_System_Web_Mvc_ActionResult callInfo);

        [NonAction]
        public override System.Web.Mvc.ActionResult GridGetAllPromo()
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.GridGetAllPromo);
            GridGetAllPromoOverride(callInfo);
            return callInfo;
        }

        [NonAction]
        partial void GridGetAllPromoDetailOverride(T4MVC_System_Web_Mvc_ActionResult callInfo, int idp);

        [NonAction]
        public override System.Web.Mvc.ActionResult GridGetAllPromoDetail(int idp)
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.GridGetAllPromoDetail);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "idp", idp);
            GridGetAllPromoDetailOverride(callInfo, idp);
            return callInfo;
        }

        [NonAction]
        partial void GridGetAllPromoPagerOverride(T4MVC_System_Web_Mvc_ActionResult callInfo, string txtSearch, int? page);

        [NonAction]
        public override System.Web.Mvc.ActionResult GridGetAllPromoPager(string txtSearch, int? page)
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.GridGetAllPromoPager);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "txtSearch", txtSearch);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "page", page);
            GridGetAllPromoPagerOverride(callInfo, txtSearch, page);
            return callInfo;
        }

        [NonAction]
        partial void GridGetAllPromoDetailPagerOverride(T4MVC_System_Web_Mvc_ActionResult callInfo, string txtSearch, int idp, int? page);

        [NonAction]
        public override System.Web.Mvc.ActionResult GridGetAllPromoDetailPager(string txtSearch, int idp, int? page)
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.GridGetAllPromoDetailPager);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "txtSearch", txtSearch);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "idp", idp);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "page", page);
            GridGetAllPromoDetailPagerOverride(callInfo, txtSearch, idp, page);
            return callInfo;
        }

        [NonAction]
        partial void CheckDuplicatePromoCodeOverride(T4MVC_System_Web_Mvc_JsonResult callInfo, string promoCode);

        [NonAction]
        public override System.Web.Mvc.JsonResult CheckDuplicatePromoCode(string promoCode)
        {
            var callInfo = new T4MVC_System_Web_Mvc_JsonResult(Area, Name, ActionNames.CheckDuplicatePromoCode);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "promoCode", promoCode);
            CheckDuplicatePromoCodeOverride(callInfo, promoCode);
            return callInfo;
        }

        [NonAction]
        partial void UploadFromExelOverride(T4MVC_System_Web_Mvc_ActionResult callInfo, System.Web.HttpPostedFileBase excelFile, int id);

        [NonAction]
        public override System.Web.Mvc.ActionResult UploadFromExel(System.Web.HttpPostedFileBase excelFile, int id)
        {
            var callInfo = new T4MVC_System_Web_Mvc_ActionResult(Area, Name, ActionNames.UploadFromExel);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "excelFile", excelFile);
            ModelUnbinderHelpers.AddRouteValues(callInfo.RouteValueDictionary, "id", id);
            UploadFromExelOverride(callInfo, excelFile, id);
            return callInfo;
        }

    }
}

#endregion T4MVC
#pragma warning restore 1591, 3008, 3009, 0108, 0114
